unit Unit1;
{
 component handling

 --history

 version 1 18-08-2008
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, davArrayBtn, ExtCtrls, Buttons, printers, clipbrd;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    mainbtn: TDavArrayBtn;
    OVtext: TStaticText;
    topbox: TGroupBox;
    coordbox: TGroupBox;
    msgbox: TStaticText;
    bottombox: TGroupBox;
    navBtn: TDavArrayBtn;
    Label1: TLabel;
    mouseXtext: TStaticText;
    mouseYtext: TStaticText;
    Image1: TImage;
    navtimer: TTimer;
    calcBtn: TBitBtn;
    Btext: TStaticText;
    Label2: TLabel;
    Label3: TLabel;
    Atext: TStaticText;
    AanglesSelect: TComboBox;
    Banglesselect: TComboBox;
    Label4: TLabel;
    Label5: TLabel;
    scalebox: TComboBox;
    xtoptext: TStaticText;
    ytoptext: TStaticText;
    xbottext: TStaticText;
    ybottext: TStaticText;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    AtextBtn: TSpeedButton;
    BtextBtn: TSpeedButton;
    EditOKBtn: TBitBtn;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    PrintDialog1: TPrintDialog;
    SaveDialog2: TSaveDialog;
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure mainbtnBtnPaint(sender: TObject; BtnNr: Byte;
      status: TBtnStatus);
    procedure mainbtnLeave(Sender: TObject);
    procedure mainbtnBtnChange(sender: TObject; BtnNr: Byte;
      status: TBtnStatus; button: TMouseButton);
    procedure PaintBox1Paint(Sender: TObject);
    procedure navBtnBtnPaint(sender: TObject; BtnNr: Byte;
      status: TBtnStatus);
    procedure mainbtnEnter(Sender: TObject);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure navBtnBtnChange(sender: TObject; BtnNr: Byte;
      status: TBtnStatus; button: TMouseButton);
    procedure navtimerTimer(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure calcBtnClick(Sender: TObject);
    procedure AanglesSelectEnter(Sender: TObject);
    procedure BanglesselectEnter(Sender: TObject);
    procedure AanglesSelectExit(Sender: TObject);
    procedure scaleboxEnter(Sender: TObject);
    procedure navBtnEnter(Sender: TObject);
    procedure scaleboxChange(Sender: TObject);
    procedure AtextBtnClick(Sender: TObject);
    procedure BanglesselectChange(Sender: TObject);
    procedure AanglesSelectChange(Sender: TObject);
    procedure BtextBtnClick(Sender: TObject);
    procedure EditOKBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    procedure EditEnter(sender:TObject);
  end;

type Tmsg = (msgInfo,msgError,msgMessage,msgOld);
     TmainBtn = (mbLoad,mbPrint,mbResetA,mbModA,mbShiftA,mbHelp,
                 mbSave,mbreset,mbResetB,mbModB,mbShiftB,mbInfo,mbOff);

var Form1: TForm1;
    mainbutton : TmainBtn = mbOff;

procedure msg(mT : Tmsg; msgText : string);

implementation

{$R *.DFM}

uses paramUnit,OvUnit,helpunit,infounit;

type TsaveFormat = record
                    id      : string[7];
                    scale   : byte;
                    Apoly   : TPoly12;
                    Bpoly   : Tpoly12;
                    top    : TrealPoint;
                    bottom : Trealpoint;
                   end;
const formcaption = 'POLYGON OVERLAP:';

var navcode : byte; //action code for navigation timer
    shiftKey : boolean = false;
    sf : Tsaveformat;
    OVOk : boolean = false;//set if overlap calculated;

procedure setEdit(ed : TObject; n : byte);forward;
procedure savepoly;forward;
procedure loadpoly;forward;
procedure printpolys;forward;

procedure TForm1.EditEnter(sender:Tobject);
//to release the calculate button on entering an edit component
begin
 if mainbutton <> mbOff then
  begin
   mainBtn.BtnRelease(byte(mainbutton));
   mainbutton := mbOff;
  end;
end;

procedure msg(mT : Tmsg; msgText : string);
//msgNr = 0 restores old info
const savetext : string = '';
      savetype : Tmsg = msgmessage;
begin
 if mT = msgOld then
  begin
   msgText := saveText;
   mt := savetype;
  end;
 with form1.msgbox do
  begin
   case mt of
           msgInfo    : begin
                         font.color := $808080;
                        end;
           msgerror   : begin
                         font.color := $0000ff;
                         saveText := msgText;
                         savetype := mT;
                        end;
           msgmessage : begin
                         font.color := $000000;
                         saveText := msgText;
                         savetype := mT;
                        end;
   end;//case
   caption := msgText;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var i : byte;
begin
 caption := formcaption;
 with mainbtn do
  begin
   btnwidth := 70;
   btnHeight := 30;
  end;
 for i := 1 to 24 do
  begin
   ABEdit[i] := Tedit.create(form1);
   ABEdit[i].parent := coordbox;
   ABEdit[i].onEnter := EditEnter;
   setEdit(ABedit[i], i);
   ABEdit[i].visible := false;
  end;
 msg(msgMessage,'Welcome at the Polygon-Overlap-Calculator');
 createMaps;
 initparams;
 with navBtn do
  begin
   btnwidth := 20;
   btnheight := 20;
   for i := 0 to 8 do
    case i of
     0,2,4,6,8 : btnhide(i);
     1,3,5,7   : setbtnOpmode(i,omMom);
    end;//case
   end;
end;

procedure setEdit(ed : TObject; n : byte);
begin
 with ed as TEdit do
  begin
   dec(n);
   left := 5 + (n mod 2) * 60;
   top := 30 + (n div 2) * 30;
   width := 55;
   maxlength := 7;
   font.color := $0;
  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
var i : byte;
begin
 for i := 1 to 24 do ABedit[i].free;
 freeMaps;
end;

procedure TForm1.FormPaint(Sender: TObject);
var i : byte;
    r : Trect;
    x1,y1,x2,y2 : word;
begin
 with canvas do
  begin
   brush.Style := bsclear;
   font.color := $c0;
   for i := 1 to 12 do
    begin
     textout(10,coordbox.top + i*30,inttostr(i));
    end;
  end;//width

//   -- rand om paintbox1 --

 x1 := paintbox1.Left - 10;
 x2 := x1 + paintbox1.width + 21;
 y1 := paintbox1.top - 10;
 y2 := y1 + paintbox1.Height + 21;
 with canvas do
  begin
   brush.style := bsSolid;
   brush.color := $e0ffff;
   r.left := x1;                            //top
   r.right := x2;
   r.top := y1;
   r.bottom := y1 + 10;
   fillrect(r);
   r.right := x1 + 10;                              //left
   r.bottom := y2;
   fillrect(r);
   r.right := x2;       //bottom
   r.top := y2 - 10;
   fillrect(r);
   r.left := x2 - 10;;   //right
   r.top:= y1;
   fillrect(r);
   for i := 0 to 1 do
    begin
     pen.color := $000000;
     moveto(x2-i,y1+i);
     lineto(x1+i,y1+i);
     lineto(x1+i,y2-i);
     pen.color := $c0c0c0;
     lineto(x2-i,y2-i);
     lineto(x2-i,y1+i);
    end;//for
  end;//with canvas
end;

{-----------button paints-------------}

procedure TForm1.mainbtnBtnPaint(sender: TObject; BtnNr: Byte;
  status: TBtnStatus);
const btntext : array[0..11] of string =
                ('Load','Print','Reset-A','Modify-A','Shift-A','help',
                 'Save','Reset','Reset-B','Modify-B','Shift-B','info');
      btnHint : array[0..11] of string =
                ('load from file','print polygons','set A to original size',
                 'change A-points','shift A-polygon','show help information',
                 'save to file','Reset all','set B to original size',
                 'change B-points','shift B-polygon','show product information');
var r : Trect;
    x,y : integer;
    s : string;
begin
 s := btntext[btnNr];
 with mainbtn do with canvas do
  begin
   r := getbtnrect(btnNr);
   if getbtnstatus(btnNr) = stDown then
    begin
     font.style := [fsbold];
     font.color := $000000;
    end
   else
    begin
     font.style := [];
     font.color := $ffffff;
    end;
   brush.style := bsClear;
   font.Height := 18;
   x := r.left+trunc((btnwidth-textwidth(s)) div 2);
   y := r.top + trunc((btnheight-textheight(s)) div 2);
   textout(x,y,s);
  end;
//----hint
 if status <> stFlat then msg(msgInfo,btnHint[btnNr])
  else msg(msgOld,'');
end;

procedure TForm1.navBtnBtnPaint(sender: TObject; BtnNr: Byte;
  status: TBtnStatus);
type TA = array[1..8] of byte;
const RAR : TA = ($95,$51,$54,$14,$16,$56,$59,$95);
      TAR : TA = ($51,$15,$45,$49,$69,$65,$95,$51);
      LAR : TA = ($15,$59,$56,$96,$94,$54,$51,$15);
      BAR : TA = ($59,$95,$65,$61,$41,$45,$15,$59);
var i : byte;
    AA : TA;
    x,y : integer;
    r : Trect;
begin
 case btnNr of
  1 : AA := TAR;
  3 : AA := LAR;
  5 : AA := RAR;
  7 : AA := BAR;
 end;
 with navBtn do with canvas do
  begin
   r := getBtnrect(btnNr);
   if getbtnstatus(btnNr) = stDown then pen.color := $00c000
    else pen.color := $e0e0e0;
   pen.width := 2;
   for i := 1 to 8 do
    begin
     y := r.top + (AA[i] and $f) * 2;
     x := r.left + (AA[i] shr 4) * 2;
     if i = 1 then moveto(x,y) else lineto(x,y);
    end;
  end;//with
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
 paintbox1.canvas.draw(0,0,map2);
end;

{------------button change--------------}

procedure TForm1.mainbtnEnter(Sender: TObject);
//release buttons on entry
begin
 if mainbutton <> mbOff then
  begin
   mainBtn.btnRelease(byte(mainbutton));
   mainbutton := mbOff;
  end;
end;

procedure TForm1.mainbtnLeave(Sender: TObject);
//release erase,default buttons on exit
begin
 case mainbutton of
  mbReset,
  mbResetA,
  mbResetB,
  mbLoad,
  mbSave,
  mbPrint,
  mbHelp,
  mbInfo  : mainBtn.BtnRelease(byte(mainbutton));
 end;//case
end;

procedure TForm1.mainbtnBtnChange(sender: TObject; BtnNr: Byte;
  status: TBtnStatus; button: TMouseButton);
begin
 activecontrol := nil;
 case mainbutton of
  mbLoad,
  mbPrint,
  mbResetA,
  mbModA,
  mbShiftA,
  mbSave,
  mbreset,
  mbResetB,
  mbModB,
  mbShiftB : ;//future close actions?
 end;
 mainbutton := mbOff;
 if status <> stDown then exit;
//
 mainbutton := TMainbtn(btnNr);
 msg(msgMessage,'');             //clear message
 case mainbutton of
  mbReset    : begin
                initparams;
                msg(msgMessage,'');
               end;
  mbModA,
  mbShiftA   : selectA;
  mbModB,
  mbShiftB   : selectB;
  mbResetA   : begin
                makeAPoly;
                selectA;
                paintshowpolys;
               end;
  mbResetB   : begin
                makeBPoly;
                selectB;
                paintshowpolys;
               end;
  mbSave     : savePoly;
  mbLoad     : loadpoly;
  mbPrint    : printpolys;
  mbHelp     : showhelp;
  mbInfo     : showInfo;
 end;//case
end;

procedure TForm1.navBtnBtnChange(sender: TObject; BtnNr: Byte;
  status: TBtnStatus; button: TMouseButton);
const dirconvert : array[0..8] of byte = (0,2,0,3,0,1,0,4,0);
begin
 if status = stFlat then
  begin
   navcode := 0;
   exit;
  end;
 if status = stDown then
  begin
   OVOK := false;
   navcode := dirconvert[btnNr];
   with navtimer do
    begin
     interval := 250;
     enabled := true;
     navTimerTimer(self);
    end;
  end;//if
end;

procedure TForm1.navtimerTimer(Sender: TObject);
//navigation timer event. navcode defines action
var dx,dy : double;
    delta : byte;
begin
 if shiftkey then delta := 1 else delta := 20;
 dx := pixeltoX(delta) - pixeltoX(0);
 dy := pixeltoY(delta) - pixelToY(0);
 case navcode of
  0 : begin
       navTimer.enabled := false;
       exit;
      end;
  1 : begin
       LBottom.x := Lbottom.x + dx;
       RTop.x := RTop.x + dx;
      end;
  2 : begin
       LBottom.y := Lbottom.y - dy;
       RTop.y := RTop.y - dy;
      end;
  3 : begin
       LBottom.x := Lbottom.x - dx;
       RTop.x := RTop.x - dx;
      end;
  4 : begin
       LBottom.y := Lbottom.y + dy;
       RTop.y := RTop.y + dy;
      end;
 end;//case
 topbottotext;
 paintshowpolys;
 with navtimer do if interval > 100 then interval := interval - 20;
end;

procedure TForm1.EditOKBtnClick(Sender: TObject);
begin
 edittopoly;
 OVOK := false;
end;

//----- mouse events ------------

procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
const oldRect : TRect = (left:0; top:0; right:10; bottom:10);//cursor -0-
begin
 with paintbox1 do with canvas do
  begin
   copyrect(oldrect,map2.canvas,oldrect);  //restore area
   if (ssShift in shift) = false then
    begin
     x := ((x+5) div 10) * 10;
     y := ((y+5) div 10) * 10;
    end;
   mouseXtext.Caption := formatFloat(ff,pixelToX(x));
   mouseYtext.Caption := formatFloat(ff,pixelToY(y));
   draw(x-5,y-5,image1.picture.bitmap);
  end;//with
 with oldrect do
  begin
   left := x - 6;
   right := x + 6;
   top := y - 6;
   bottom := y + 6;
  end;
 mouseX := x;
 mouseY := y;
 mouseAction := maMove;
 mouseProc; 
end;

procedure TForm1.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 mouseAction := maDown;
 mouseproc;
end;

procedure TForm1.PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 mouseAction := maUp;
 mouseProc;
end;

// --------- keyboard events ----------

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
//<CTRL>P sends Image of form to clipboard
var bm : TBitmap;
begin
 if key = VK_SHIFT then shiftkey := true;
 if (shift = [ssCTRL]) then
   case key of
    ord('P')   : begin
                  bm := getFormImage;
                  clipboard.assign(bm);
                  bm.free;
                  msg(msgMessage,'form image send to clipboard');
                 end;
    ord('K')   : begin
                  clipboard.assign(map2);
                  msg(msgMessage,'image send to clipboard');
                 end;
    ord('F')   : with savedialog2 do
                  if execute then
                   begin
                    map2.savetofile(filename);
                    msg(msgmessage,'image saved');
                   end;
   end;//case
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if key = VK_SHIFT then shiftKey := false;
end;

procedure TForm1.AanglesSelectChange(Sender: TObject);
begin
 NewAangles;
end;

procedure TForm1.BanglesselectChange(Sender: TObject);
begin
 NewBangles;
end;

procedure TForm1.calcBtnClick(Sender: TObject);
var ovlp : double;
begin
 if APosOK then Atext.caption := formatFloat(ff,PolyArea(Apoints))
  else Atext.caption := '';
 if BPosOK then Btext.caption := formatfloat(ff,PolyArea(Bpoints))
  else Btext.caption := '';
 if AposOK and BposOk then
  begin
   ovlp := overlap(Apoints,Bpoints);
   ovtext.Caption := formatfloat(ff,ovlp);
   msg(msgMessage,'overlap calculated');
   OVOk := ovlp > 0;
  end
  else
   begin
    OVtext.caption := '';
    msg(msgError,'wrong shape');
    OVOK := false;
   end; 
end;

procedure TForm1.AanglesSelectEnter(Sender: TObject);
begin
 msg(msgInfo,'specify number of A-angles');
 OVOK := false;
end;

procedure TForm1.BanglesselectEnter(Sender: TObject);
begin
 msg(msgInfo,'specify number of B-angles');
 OVOK := false;
end;

procedure TForm1.AanglesSelectExit(Sender: TObject);
begin
 msg(msgOld,'');
end;

procedure TForm1.scaleboxEnter(Sender: TObject);
begin
 msg(msgInfo,'select scale');
 OVOK := false;
end;

procedure TForm1.navBtnEnter(Sender: TObject);
begin
 msg(msgInfo,'move coordinate system');
end;

procedure TForm1.scaleboxChange(Sender: TObject);
begin
 newscale;
end;

procedure TForm1.AtextBtnClick(Sender: TObject);
begin
 ABselect := @Apoints;
 polytoEdit;
end;

procedure TForm1.BtextBtnClick(Sender: TObject);
begin
 ABselect := @Bpoints;
 polytoEdit;
end;

// ------ load and save ---------------

procedure savePoly;
//436 bytes
var f : file of TSaveFormat;
begin
 with sf do
  begin
   id := 'davpoly';
   scale := form1.scalebox.itemindex;
   Apoly := Apoints;
   Bpoly := Bpoints;
   top := Rtop;
   bottom := Lbottom
  end;
 if form1.savedialog1.execute then
  begin
   assignfile(f,form1.savedialog1.filename);
   rewrite(f);
   write(f,sf);
   closefile(f);
   form1.caption := formcaption + ' '+form1.savedialog1.filename;
  end;
end;

procedure loadpoly;
var f : file of TSaveFormat;
begin
 with form1 do
  begin
   Atext.caption := '';
   Btext.caption := '';
   OVtext.caption := '';
//
   opendialog1.filename := '';
   if opendialog1.execute then
    begin
     assignfile(f,opendialog1.filename);
     reset(f);
     read(f,sf);
     closefile(f);
     if sf.id = 'davpoly' then
      begin
       Apoints := sf.Apoly;
       Bpoints := sf.Bpoly;
       Rtop := sf.top;
       LBottom := sf.bottom;
       with scalebox do itemindex := sf.scale;
       with Aanglesselect do itemindex := items.indexof(inttostr(APoints.angles));
       with Banglesselect do itemindex := items.indexof(inttostr(BPoints.angles));
       PolyToEdit;
       paintShowPolys;
       caption := formcaption + ' '+form1.opendialog1.filename;
      end
     else msg(msgError,'cannot read file');
    end;//if execute
  end;//with form1  
end;

// --- print --------------

function getPrx(xr : word;const s : string) : integer;
//return xtartpixel x of string for right alignment to xr
//on printer canvas
var offset : word;
    i : byte;
begin
 offset := 0;
 for i := 1 to length(s) do
  offset := offset + printer.canvas.TextWidth(s[i]);
 result := xr - offset;
end;

function clipline(var r : Trect; x1,y1,x2,y2 : integer) : byte;
//modify coordinates to fit cliprectangle
//result = code
//draw line on printercanvas using predefined properties
type Tvector = record
                vcode : byte;//  1xx = fa < 0  x1x = 0 < fa < 1   xx1 = fa > 1
                v     : boolean; //true if intersecting clip edge
                xs,ys : single;  //intersection point
               end;
var a,b,c,d,e,f,discr,fa,fb : single;
    i,code : byte;
    points : array[1..2] of TPoint;
    pTop : byte;
    clipdone : boolean;
begin
 pTop := 0;
 clipdone := false;
 code := 0;
 a := x2-x1;              //line vector (a,c)
 c := y2-y1;
 i := 0;
 repeat
  inc(i);                //select . build clip edge vector (b,d)
  case i of
    1 : begin
         b := r.left - r.right;
         d := 0;
         e := r.left - x1;
         f := r.top - y1;
        end;
    2 : begin
         f := r.bottom - y1;
        end;
    3 : begin
         b := 0;
         d := r.top - r.bottom;
         f := r.top - y1;
        end;
    4 : begin
         e := r.right - x1;
        end;
  end;//case;
  discr := a*d - b*c;
  if discr <> 0 then
   begin
    fb := (a*f - c*e)/discr;
    if (fb >= 0) and (fb <= 1) then
     begin
      fa := (d*e - b*f)/discr;
      if fa < 0 then code := code or $4
       else if fa > 1 then code := code or $1
        else
         begin
          code := code or $2;     //intersection found
          inc(pTop);
          points[pTop].x := x1 + trunc(fa*a+0.5);
          points[pTop].y := y1 + trunc(fa*c+0.5);
         end;
      case code of
        $2 : if pTop = 2 then
              begin
               clipdone := true;
               x1 := points[1].x;
               y1 := points[1].y;
               x2 := points[2].x;
               y2 := points[2].y;
              end;
        $3 : begin                    //vector goes outside
              clipdone := true;
              x1 := points[pTop].x;
              y1 := points[pTop].y;
             end;
        $5 : clipdone := true;       //vector inside
        $6 : begin                   //vector goes inside
              clipdone := true;
              x2 := points[pTop].x;
              y2 := points[pTop].y;
             end;
      end;//case
    end;//if fb...
   end;//if discr
 until clipdone or (i = 4);
 result := code;
//begindoc command must precede the next code
 if clipdone then
  with printer do
   with canvas do
    begin
     moveto(x1,y1);
     lineto(x2,y2);
    end;
//enddoc command must follow to start printing
end;

procedure printpoints(const s : string; var p : TPoly12 ;x1,x2,x3,y : integer);
//print p at (x,y) left top
//x1:right of 1.  x2:right of x   x3:right of y
var i : byte;
    ss : string;
begin
 with printer do
  with canvas do
   begin
    textout(x1,y,s);
    ss := 'x';
    textout(getPrx(x2,ss),y,ss);
    ss := 'y';
    textout(getPrx(x3,ss),y,ss);
    y := y + font.height;
    with p do
     for i := 1 to angles do
      begin
       y := y + font.height;
       ss := inttostr(i)+'.';
       textout(getPrx(x1,ss),y,ss);
       ss := formatfloat(ff,coord[i].x);
       textout(getPrx(x2,ss),y,ss);
       ss := formatfloat(ff,coord[i].y);
       textout(getPrx(x3,ss),y,ss);
      end;
   end;
end;

function InRect(var r : Trect;x,y : integer) : boolean;
//test (x,y) in range of r
begin
 result := (x >= r.left) and (x <= r.right) and
           (y >= r.top)  and (y <= r.bottom);
end;

procedure printpolys;
var mult : single;
    i,x1,x2,y1,y2,px,py,xs,ys,oldpx,oldpy : integer;
    mlt,code : byte;
    r : Trect;
begin
 if form1.printdialog1.execute then
  with printer do
   with canvas do
    begin
     begindoc;
//     
      x1 := trunc(0.1*pagewidth);
      y1 := trunc(0.1*pageheight);
      mult := 0.8*pagewidth / (form1.paintbox1.width-1);//scale multiplier
      x2 := x1 + trunc(mult * form1.paintbox1.width);
      font.name := 'arial';
      font.color := $000000;
      font.height := trunc(mult * 25);
      textout(x1,y1,'DavData  Polygon - Overlap - Calculator');
      y1 := y1 + trunc(mult * 30);
      font.height := trunc(mult * 18);
      textout(x1,y1,'date : '+ datetostr(date));
      y1 := y1 + trunc(mult * 25);
      textout(x1,y1,'scale = '+ formatfloat(ff,xyscale));
      y1 := y1 + trunc(mult * 25);
      textout(x1,y1,'LeftBottom = ('+formatFloat(ff,Lbottom.x)+' , '+
                                     formatFloat(ff,Lbottom.y)+')   '+
                    'RightTop = ('+formatFloat(ff,Rtop.x)+' , '+
                                  formatFloat(ff,Rtop.y)+')');
      y1 := y1 + trunc(mult * 30);
      textout(x1,y1,'A-area = '+form1.Atext.caption+'   '
                   +'B-area = '+form1.Btext.caption+'   '
                   +'Overlap-area = '+form1.OVtext.caption);
      y1 := y1 + trunc(mult * 30);                    //coord system top
      y2 := y1 + trunc(mult * form1.paintbox1.height);//coord system bottom
      pen.width := trunc(mult+0.5);
      pen.color := $c0c0c0;
      font.color := $000000;
      font.height := trunc(mult*18);
      for i := 0 to 40 do              //vertical raster
       begin
        px := x1 + trunc(i*20*mult);
        moveto(px,y1);
        lineto(px,y2);
       end;
      for i := 0 to 25 do             //horizontal rster
       begin
        py := y1 + trunc(i*20*mult);
        moveto(x1,py);
        lineto(x2,py);
       end;
      pen.color := $000000;           //frame
      moveto(x1,y1);
      lineto(x1,y2);
      lineto(x2,y2);
      lineto(x2,y1);
      lineto(x1,y1);
      pen.Width := trunc(2*mult+0.5);
      brush.style := bsClear;
      pen.color := $ff0000;
      r.left := x1;                     //setup clipping rectangle
      r.top := y1;
      r.right := x2;
      r.bottom := y2;
      with Apoints do                   //paint Apoints, edges
       begin
        xs := x1 + trunc(mult*XtoPixel(coord[1].x));
        ys := y1 + trunc(mult*YtoPixel(coord[1].y));
        oldpx := xs;
        oldpy := ys;
        for i := 2 to Apoints.angles do
         begin
          px := x1 + trunc(mult*XtoPixel(coord[i].x));
          py := y1 + trunc(mult*YtoPixel(coord[i].y));
          code := clipline(r,oldpx,oldpy,px,py);
          if (code = 3) or (code = 5) then textout(px,py,inttostr(i));
          oldpx := px;
          oldpy := py;
         end;
        code := clipline(r,oldpx,oldpy,xs,ys);
        if (code = 3) or (code = 5) then textout(xs,ys,'1');
       end;//with
       pen.color := $0000ff;
       with Bpoints do                 //paint Bpoints
        begin
         xs := x1 + trunc(mult*XtoPixel(coord[1].x));
         ys := y1 + trunc(mult*YtoPixel(coord[1].y));
         oldpx := xs;
         oldpy := ys;
         for i := 2 to Bpoints.angles do
         begin
          px := x1 + trunc(mult*XtoPixel(coord[i].x));
          py := y1 + trunc(mult*YtoPixel(coord[i].y));
          code := clipline(r,oldpx,oldpy,px,py);
          if (code = 3) or (code = 5) then textout(px,py,inttostr(i));
          oldpx := px;
          oldpy := py;
         end;
         code := clipline(r,oldpx,oldpy,xs,ys);
         if (code = 3) or (code = 5) then textout(xs,ys,'1');
        end;//with
       brush.color := $000000;
       brush.Style := bsSolid;
       mlt := trunc(mult * 3);            //paint innerpoints
       with polylist do                   //if calculated
        if OVOK then
         for i := 1 to top do
          begin
           px := x1 + trunc(mult * Xtopixel(coord[i].x));
           py := y1 + trunc(mult * Ytopixel(coord[i].y));
           if InRect(r,px,py) then fillrect(rect(px-mlt,py-mlt,px+mlt,py+mlt));
          end;
//                                       //coord printing
       brush.style := bsClear;
       y1 := y2 + trunc(mult * 40);
       printpoints('APoints',Apoints,x1,x1 + trunc(mult*100),
                                        x1 + trunc(mult * 200),y1);
       x1 := x1 + trunc(mult * 300);
       printpoints('BPoints',Bpoints,x1,x1 + trunc(mult*100),
                                        x1 + trunc(mult * 200),y1);
//
     enddoc;
    end;//if execute
end;

end.
